describe :method_call, :shared => true do
  it "invokes the method with the specified arguments, returning the method's return value" do
    m = 12.method("+")
    m.send(@method, 3).should == 15
    m.send(@method, 20).should == 32

    m = MethodSpecs::Methods.new.method(:attr=)
    m.send(@method, 42).should == 42
  end

  it "raises an ArgumentError when given incorrect number of arguments" do
    lambda {
      MethodSpecs::Methods.new.method(:two_req).send(@method, 1, 2, 3)
    }.should raise_error(ArgumentError)
    lambda {
      MethodSpecs::Methods.new.method(:two_req).send(@method, 1)
    }.should raise_error(ArgumentError)
  end

  ruby_version_is "1.9" do
    describe "for a Method generated by respond_to_missing?" do
      it "it invokes method_missing with the specified arguments and returns the result" do
        @m = MethodSpecs::Methods.new
        @m.method(:handled_via_method_missing).send(@method, :argument).should == [:argument]
      end
    end
  end
end
